Index: /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/ini_histrac.h
===================================================================
--- /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/ini_histrac.h	(revision 633)
+++ /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/ini_histrac.h	(revision 634)
@@ -4,12 +4,14 @@
          CALL ymds2ju(annee_ref, 1, day_ref, 0.0, zjulian)
 c
-         CALL gr_fi_ecrit(1,klon,iim,jjm+1,xlon,zx_lon)
-         DO i = 1, iim
-            zx_lon(i,1) = xlon(i+1)
-            zx_lon(i,jjm+1) = xlon(i+1)
-         ENDDO
-         CALL gr_fi_ecrit(1,klon,iim,jjm+1,xlat,zx_lat)
-         CALL histbeg("histrac", iim,zx_lon(:,1), jjm+1,zx_lat(1,:),
-     .                 1,iim,1,jjm+1, itau_phy, zjulian, pdtphys,
+cym         CALL gr_fi_ecrit(1,klon,iim,jjm+1,xlon,zx_lon)
+cym         DO i = 1, iim
+cym            zx_lon(i,1) = xlon(i+1)
+cym            zx_lon(i,jjm+1) = xlon(i+1)
+cym         ENDDO
+cym         CALL gr_fi_ecrit(1,klon,iim,jjm+1,xlat,zx_lat)
+cym         CALL histbeg("histrac", iim,zx_lon(:,1), jjm+1,zx_lat(1,:),
+cym     .                 1,iim,1,jjm+1, itau_phy, zjulian, pdtphys,
+cym     .                 nhori, nid_tra)
+         CALL histbeg_phy("histrac", itau_phy, zjulian, pdtphys,
      .                 nhori, nid_tra)
          CALL histvert(nid_tra, "presnivs", "Vertical levels", "mb",
@@ -17,10 +19,14 @@
 
 #ifdef INCA_AER
-         CALL histbeg("histrac_aer", iim,zx_lon, jjm+1,zx_lat,
-     .                 1,iim,1,jjm+1,  itau_phy, zjulian, pdtphys,
+cym         CALL histbeg("histrac_aer", iim,zx_lon, jjm+1,zx_lat,
+cym     .                 1,iim,1,jjm+1,  itau_phy, zjulian, pdtphys,
+cym     .                 nhori, nid_tra2)
+         CALL histbeg_phy("histrac_aer", itau_phy, zjulian, pdtphys,
      .                 nhori, nid_tra2)
 
-         CALL histbeg("histrac_inst", iim,zx_lon, jjm+1,zx_lat,
-     .                 1,iim,1,jjm+1,  itau_phy, zjulian, pdtphys,
+cym         CALL histbeg("histrac_inst", iim,zx_lon, jjm+1,zx_lat,
+cym     .                 1,iim,1,jjm+1,  itau_phy, zjulian, pdtphys,
+cym     .                 nhori, nid_tra3)
+         CALL histbeg_phy("histrac_inst",itau_phy, zjulian, pdtphys,
      .                 nhori, nid_tra3)
 
@@ -42,47 +48,47 @@
 c
          CALL histdef(nid_tra, "phis", "Surface geop. height", "-",
-     .                iim,jjm+1,nhori, 1,1,1, -99, 32,
+     .                iim,jjphy_nb,nhori, 1,1,1, -99, 32,
      .                "once",  zsto,zout)
 c
          CALL histdef(nid_tra, "aire", "Grid area", "-",
-     .                iim,jjm+1,nhori, 1,1,1, -99, 32,
+     .                iim,jjphy_nb,nhori, 1,1,1, -99, 32,
      .                "once",  zsto,zout)
 #ifdef INCA
          CALL histdef(nid_tra, "ps", "Surface pressure", "Pa",
-     .                iim,jjm+1,nhori, 1,1,1,-99, 32,
+     .                iim,jjphy_nb,nhori, 1,1,1,-99, 32,
      .                "ave(X)", zsto,zout)
 
          CALL histdef(nid_tra, "ptrop", "Tropopause pressure", "Pa",
-     .                iim,jjm+1,nhori, 1,1,1,-99, 32,
+     .                iim,jjphy_nb,nhori, 1,1,1,-99, 32,
      .                "ave(X)", zsto,zout)
 
 C   3d FIELDS
          CALL histdef(nid_tra, "temp", "Air temperature", "K",
-     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .                iim,jjphy_nb,nhori, klev,1,klev,nvert, 32,
      .                "ave(X)", zsto,zout)
 
          CALL histdef(nid_tra, "u", "zonal wind component", "m/s",
-     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .                iim,jjphy_nb,nhori, klev,1,klev,nvert, 32,
      .                "ave(X)", zsto,zout)
 
          CALL histdef(nid_tra, "v", "zonal wind component", "m/s",
-     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .                iim,jjphy_nb,nhori, klev,1,klev,nvert, 32,
      .                "ave(X)", zsto,zout)
 
          CALL histdef(nid_tra, "h2o", "Specific Humidity", "MMR",
-     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .                iim,jjphy_nb,nhori, klev,1,klev,nvert, 32,
      .                "ave(X)", zsto,zout)
 
          CALL histdef(nid_tra, "pmid", "Pressure", "Pa",
-     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .                iim,jjphy_nb,nhori, klev,1,klev,nvert, 32,
      .                "ave(X)", zsto,zout)
 
          CALL histdef(nid_tra, "pdel", "Delta Pressure", "Pa",
-     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .                iim,jjphy_nb,nhori, klev,1,klev,nvert, 32,
      .                "ave(X)", zsto,zout)
 
 ! MS info
          CALL histdef(nid_tra, "airm", "Air mass", "kg",
-     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .                iim,jjphy_nb,nhori, klev,1,klev,nvert, 32,
      .                "ave(X)", zsto,zout)
 
@@ -92,5 +98,5 @@
          WRITE(str2,'(i2.2)') it
          CALL histdef(nid_tra, "j"//str2,"j"//str2, "CM-3 S-1",
-     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .                iim,jjphy_nb,nhori, klev,1,klev,nvert, 32,
      .                "ave(X)", zsto,zout)
          ENDDO
@@ -98,5 +104,5 @@
          WRITE(str2,'(i2.2)') it
          CALL histdef(nid_tra, "w"//str2,"w"//str2, "S-1",
-     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .                iim,jjphy_nb,nhori, klev,1,klev,nvert, 32,
      .                "ave(X)", zsto,zout)
          ENDDO
@@ -105,5 +111,5 @@
          WRITE(str2,'(i2.2)') it
          CALL histdef(nid_tra, "ext"//str2,"ext"//str2, "CM-3 S-1",
-     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .                iim,jjphy_nb,nhori, klev,1,klev,nvert, 32,
      .                "ave(X)", zsto,zout)
          ENDDO
@@ -112,5 +118,5 @@
          WRITE(str2,'(i2.2)') it
          CALL histdef(nid_tra, "INV"//str2, "INV"//str2, "CM-3",
-     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .                iim,jjphy_nb,nhori, klev,1,klev,nvert, 32,
      .                "ave(X)", zsto,zout)
          ENDDO
@@ -118,20 +124,20 @@
 #else
          CALL histdef(nid_tra, "jO3","jO3", "CM-3 S-1",
-     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .                iim,jjphy_nb,nhori, klev,1,klev,nvert, 32,
      .                "ave(X)", zsto,zout)
          CALL histdef(nid_tra, "jNO2","jNO2", "CM-3 S-1",
-     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .                iim,jjphy_nb,nhori, klev,1,klev,nvert, 32,
      .                "ave(X)", zsto,zout)
          CALL histdef(nid_tra, "jH2O2","jH2O2", "CM-3 S-1",
-     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .                iim,jjphy_nb,nhori, klev,1,klev,nvert, 32,
      .                "ave(X)", zsto,zout)
          CALL histdef(nid_tra, "wHNO3","wHNO3", "S-1",
-     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .                iim,jjphy_nb,nhori, klev,1,klev,nvert, 32,
      .                "ave(X)", zsto,zout)
          CALL histdef(nid_tra, "kN2O5", "kN2O5","CM-3 S-1",
-     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .                iim,jjphy_nb,nhori, klev,1,klev,nvert, 32,
      .                "ave(X)", zsto,zout)
          CALL histdef(nid_tra, "LghtNO","LghtNO", "CM-3 S-1",
-     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .                iim,jjphy_nb,nhori, klev,1,klev,nvert, 32,
      .                "ave(X)", zsto,zout)
 #endif
@@ -139,5 +145,5 @@
          DO it=1, grpcnt
          CALL histdef(nid_tra, grpsym(it), grpsym(it), "VMR",
-     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .                iim,jjphy_nb,nhori, klev,1,klev,nvert, 32,
      .                "ave(X)", zsto,zout)
          ENDDO
@@ -147,11 +153,11 @@
 
         CALL histdef(nid_tra2, "scavcoef_st","scavcoef_st", "S-1",
-     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .                iim,jjphy_nb,nhori, klev,1,klev,nvert, 32,
      .                "ave(X)", zsto,zout)
         CALL histdef(nid_tra2, "scavcoef_cv","scavcoef_cv", "S-1",
-     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .                iim,jjphy_nb,nhori, klev,1,klev,nvert, 32,
      .                "ave(X)", zsto,zout)
         CALL histdef(nid_tra2, "AngstroemComp","AngstroemComp",
-     .      "angs comp", iim,jjm+1,nhori, 1,1,1, -99, 32,
+     .      "angs comp", iim,jjphy_nb,nhori, 1,1,1, -99, 32,
      .      "ave(X)", zsto,zout)
 
@@ -164,52 +170,52 @@
 
          CALL histdef(nid_tra, "Emi_"//solsym(it), "Emi_"//solsym(it),
-     .           "kg/m2/s", iim,jjm+1,nhori, 1,1,1, -99, 32,
+     .           "kg/m2/s", iim,jjphy_nb,nhori, 1,1,1, -99, 32,
      .           "ave(X)", zsto,zout)
          CALL histdef(nid_tra, "Dep_"//solsym(it), "Dep_"//solsym(it),
-     .           "cm/s", iim,jjm+1,nhori, 1,1,1, -99, 32,
+     .           "cm/s", iim,jjphy_nb,nhori, 1,1,1, -99, 32,
      .           "ave(X)", zsto,zout)
 #ifdef INCA_AER
         IF  ((it .ge. trmx) .and. (it .le. trnx)) then
           CALL histdef(nid_tra2, "Sed_"//solsym(it), "Sed_"//solsym(it),
-     .      "kg/m2/s", iim,jjm+1,nhori, 1,1,1, -99, 32,
+     .      "kg/m2/s", iim,jjphy_nb,nhori, 1,1,1, -99, 32,
      .      "ave(X)", zsto,zout)
           CALL histdef(nid_tra2, "Dry_"//solsym(it), "Dry_"//solsym(it),
-     .      "kg/m2/s", iim,jjm+1,nhori, 1,1,1, -99, 32,
+     .      "kg/m2/s", iim,jjphy_nb,nhori, 1,1,1, -99, 32,
      .      "ave(X)", zsto,zout)
           CALL histdef(nid_tra2, "Wet_"//solsym(it), "Wet_"//solsym(it),
-     .      "kg/m2/s", iim,jjm+1,nhori, 1,1,1, -99, 32,
+     .      "kg/m2/s", iim,jjphy_nb,nhori, 1,1,1, -99, 32,
      .      "ave(X)", zsto,zout)
           CALL histdef(nid_tra2, "WetST_"//solsym(it), "WetST_"//solsym(it),
-     .      "kg/m2/s", iim,jjm+1,nhori, 1,1,1, -99, 32,
+     .      "kg/m2/s", iim,jjphy_nb,nhori, 1,1,1, -99, 32,
      .      "ave(X)", zsto,zout)
           CALL histdef(nid_tra2, "WetCV_"//solsym(it), "WetCV_"//solsym(it),
-     .      "kg/m2/s", iim,jjm+1,nhori, 1,1,1, -99, 32,
+     .      "kg/m2/s", iim,jjphy_nb,nhori, 1,1,1, -99, 32,
      .      "ave(X)", zsto,zout)
           CALL histdef(nid_tra2, "Emi_alt_"//solsym(it), "Emi_alt_"//solsym(it),
-     .      "kg/m2/s", iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .      "kg/m2/s", iim,jjphy_nb,nhori, klev,1,klev,nvert, 32,
      .      "ave(X)", zsto,zout)
           CALL histdef(nid_tra2, "Load_"//solsym(it), "Load_"//solsym(it),
-     .      "kg/m2", iim,jjm+1,nhori, 1,1,1, -99, 32,
+     .      "kg/m2", iim,jjphy_nb,nhori, 1,1,1, -99, 32,
      .      "ave(X)", zsto,zout)
           CALL histdef(nid_tra2, "SConc_"//solsym(it), "SConc_"//solsym(it),
-     .      "kg/m3", iim,jjm+1,nhori, 1,1,1, -99, 32,
+     .      "kg/m3", iim,jjphy_nb,nhori, 1,1,1, -99, 32,
      .      "ave(X)", zsto,zout)
           do la=1,las
            CALL histdef(nid_tra2, "OD_"//cla(la)//solsym(it), 
      .                            "OD_"//cla(la)//solsym(it),
-     .        "opt. depth", iim,jjm+1,nhori, 1,1,1, -99, 32,
+     .        "opt. depth", iim,jjphy_nb,nhori, 1,1,1, -99, 32,
      .        "ave(X)", zsto,zout)
           enddo
           CALL histdef(nid_tra2, "MD_"//solsym(it), "MD_"//solsym(it),
-     .      "median diameter", iim,jjm+1,nhori, klev,1,klev, nvert, 32,
+     .      "median diameter", iim,jjphy_nb,nhori, klev,1,klev, nvert, 32,
      .      "ave(X)", zsto,zout)
           CALL histdef(nid_tra3, "Inst_Load_"//solsym(it), 
      .                          "Inst_Load_"//solsym(it),
-     .      "kg/m2", iim,jjm+1,nhori, 1,1,1, -99, 32,
+     .      "kg/m2", iim,jjphy_nb,nhori, 1,1,1, -99, 32,
      .      "inst(X)", zout,zout)
         endif
 #endif
          CALL histdef(nid_tra, solsym(it), solsym(it), "VMR",
-     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .                iim,jjphy_nb,nhori, klev,1,klev,nvert, 32,
      .                "ave(X)", zsto,zout)
 #else
@@ -217,9 +223,9 @@
          iiq=niadv(iq)
          CALL histdef(nid_tra, tnom(iq), ttext(iiq), "U/kga",
-     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .                iim,jjphy_nb,nhori, klev,1,klev,nvert, 32,
      .                "ave(X)", zsto,zout)
          if (lessivage) THEN
          CALL histdef(nid_tra, "fl"//tnom(iq),"Flux "//ttext(iiq),
-     .              "U/m2/s",iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .              "U/m2/s",iim,jjphy_nb,nhori, klev,1,klev,nvert, 32,
      .              "ave(X)", zsto,zout)
          endif
@@ -228,13 +234,13 @@
          CALL histdef(nid_tra, "d_tr_th_"//tnom(iq),
      .	              "tendance thermique"// ttext(iiq), "?",
-     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .                iim,jjphy_nb,nhori, klev,1,klev,nvert, 32,
      .                "ave(X)", zsto,zout)
          CALL histdef(nid_tra, "d_tr_cv_"//tnom(iq),
      .	              "tendance convection"// ttext(iiq), "?",
-     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .                iim,jjphy_nb,nhori, klev,1,klev,nvert, 32,
      .                "ave(X)", zsto,zout)
          CALL histdef(nid_tra, "d_tr_cl_"//tnom(iq),
      .	              "tendance couche limite"// ttext(iiq), "?",
-     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .                iim,jjphy_nb,nhori, klev,1,klev,nvert, 32,
      .                "ave(X)", zsto,zout)
 c---fin Olivia	 
@@ -246,23 +252,23 @@
 !#ifdef INCA_CH4
          CALL histdef(nid_tra, "O3_column", "O3_column",
-     .           "DU", iim,jjm+1,nhori, 1,1,1, -99, 32,
+     .           "DU", iim,jjphy_nb,nhori, 1,1,1, -99, 32,
      .           "ave(X)", zsto,zout)
          CALL histdef(nid_tra, "CO_column", "CO_column",
-     .           "10^18 CM-2", iim,jjm+1,nhori, 1,1,1, -99, 32,
+     .           "10^18 CM-2", iim,jjphy_nb,nhori, 1,1,1, -99, 32,
      .           "ave(X)", zsto,zout)
          CALL histdef(nid_tra, "CH4_column", "CH4_column",
-     .           "10^18 CM-2", iim,jjm+1,nhori, 1,1,1, -99, 32,
+     .           "10^18 CM-2", iim,jjphy_nb,nhori, 1,1,1, -99, 32,
      .           "ave(X)", zsto,zout)
          CALL histdef(nid_tra, "NO2_column", "NO2_column",
-     .           "10^15 CM-2", iim,jjm+1,nhori, 1,1,1, -99, 32,
+     .           "10^15 CM-2", iim,jjphy_nb,nhori, 1,1,1, -99, 32,
      .           "ave(X)", zsto,zout)
          CALL histdef(nid_tra, "O3_ste", "O3_ste",
-     .           "CM-2 S-1", iim,jjm+1,nhori, 1,1,1, -99, 32,
+     .           "CM-2 S-1", iim,jjphy_nb,nhori, 1,1,1, -99, 32,
      .           "ave(X)", zsto,zout)
          CALL histdef(nid_tra, "O3_prod", "O3_prod", "CM-3 S-1",
-     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .                iim,jjphy_nb,nhori, klev,1,klev,nvert, 32,
      .                "ave(X)", zsto,zout)
          CALL histdef(nid_tra, "O3_loss", "O3_loss", "CM-3 S-1",
-     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .                iim,jjphy_nb,nhori, klev,1,klev,nvert, 32,
      .                "ave(X)", zsto,zout)
 
@@ -281,46 +287,46 @@
 ! for sulfur cycle
          CALL histdef(nid_tra, "SO2_p_dmsoh", "SO2_p_dmsoh", "CM-3 S-1",
-     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .                iim,jjphy_nb,nhori, klev,1,klev,nvert, 32,
      .                "ave(X)", zsto,zout)
          CALL histdef(nid_tra, "SO2_p_dmsno3", "SO2_p_dmsno3", "CM-3 S-1",
-     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .                iim,jjphy_nb,nhori, klev,1,klev,nvert, 32,
      .                "ave(X)", zsto,zout)
          CALL histdef(nid_tra, "SO2_p_h2soh", "SO2_p_h2soh", "CM-3 S-1",
-     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .                iim,jjphy_nb,nhori, klev,1,klev,nvert, 32,
      .                "ave(X)", zsto,zout)
          CALL histdef(nid_tra, "SO2_p_dmsooh", "SO2_p_dmsooh", "CM-3 S-1",
-     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .                iim,jjphy_nb,nhori, klev,1,klev,nvert, 32,
      .                "ave(X)", zsto,zout)
          CALL histdef(nid_tra, "DMSO_p_dmsoh", "DMSO_p_dmsoh", "CM-3 S-1",
-     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .                iim,jjphy_nb,nhori, klev,1,klev,nvert, 32,
      .                "ave(X)", zsto,zout)
          CALL histdef(nid_tra, "ASMSAM_p_dmsooh", "ASMSAM_p_dmsooh", "CM-3 S-1",
-     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .                iim,jjphy_nb,nhori, klev,1,klev,nvert, 32,
      .                "ave(X)", zsto,zout)
          CALL histdef(nid_tra, "ASSO4M_p_so2oh", "ASSO4M_p_so2oh", "CM-3 S-1",
-     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .                iim,jjphy_nb,nhori, klev,1,klev,nvert, 32,
      .                "ave(X)", zsto,zout)
          CALL histdef(nid_tra, "ASSO4M_p_so2h2o2", "ASSO4M_p_h2o2","CM-3 S-1",
-     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .                iim,jjphy_nb,nhori, klev,1,klev,nvert, 32,
      .                "ave(X)", zsto,zout)
          CALL histdef(nid_tra, "ASSO4M_p_so2o3", "ASSO4M_p_so2o3", "CM-3 S-1",
-     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .                iim,jjphy_nb,nhori, klev,1,klev,nvert, 32,
      .                "ave(X)", zsto,zout)
 
          CALL histdef(nid_tra, "Wet3D_SO2", "Wet3D_SO2",
-     .           "kg/m2/s", iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .           "kg/m2/s", iim,jjphy_nb,nhori, klev,1,klev,nvert, 32,
      .           "ave(X)", zsto,zout)
          CALL histdef(nid_tra, "Wet3D_DMS", "Wet3D_DMS",
-     .           "kg/m2/s", iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .           "kg/m2/s", iim,jjphy_nb,nhori, klev,1,klev,nvert, 32,
      .           "ave(X)", zsto,zout)
          CALL histdef(nid_tra, "Wet3D_HNO3", "Wet3D_HNO3",
-     .           "kg/m2/s", iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .           "kg/m2/s", iim,jjphy_nb,nhori, klev,1,klev,nvert, 32,
      .           "ave(X)", zsto,zout)
          CALL histdef(nid_tra, "Wet3D_H2O2", "Wet3D_H2O2",
-     .           "kg/m2/s", iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .           "kg/m2/s", iim,jjphy_nb,nhori, klev,1,klev,nvert, 32,
      .           "ave(X)", zsto,zout)
 
          CALL histdef(nid_tra, "PH_HIST", "pH over physics time step", "1",
-     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .                iim,jjphy_nb,nhori, klev,1,klev,nvert, 32,
      .                "ave(X)", zsto,zout)
 #endif
@@ -328,23 +334,23 @@
 #ifdef INCA_NMHC
          CALL histdef(nid_tra, "CO2_basprod", "CO2_basprod", "CM-3 S-1",
-     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .                iim,jjphy_nb,nhori, klev,1,klev,nvert, 32,
      .                "ave(X)", zsto,zout)
          CALL histdef(nid_tra, "CO2_nmhcprod", "CO2_nmhcprod", "CM-3 S-1",
-     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .                iim,jjphy_nb,nhori, klev,1,klev,nvert, 32,
      .                "ave(X)", zsto,zout)
          CALL histdef(nid_tra, "CO2_radicalprod", "CO2_radicalprod", "CM-3 S-1",
-     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .                iim,jjphy_nb,nhori, klev,1,klev,nvert, 32,
      .                "ave(X)", zsto,zout)
          CALL histdef(nid_tra, "HNO3_prod", "HNO3_prod", "CM-3 S-1",
-     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .                iim,jjphy_nb,nhori, klev,1,klev,nvert, 32,
      .                "ave(X)", zsto,zout)
          CALL histdef(nid_tra, "HNO3_loss", "HNO3_loss", "CM-3 S-1",
-     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .                iim,jjphy_nb,nhori, klev,1,klev,nvert, 32,
      .                "ave(X)", zsto,zout)
          CALL histdef(nid_tra, "CO_prod", "CO_prod", "CM-3 S-1",
-     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .                iim,jjphy_nb,nhori, klev,1,klev,nvert, 32,
      .                "ave(X)", zsto,zout)
          CALL histdef(nid_tra, "CO_loss", "CO_loss", "CM-3 S-1",
-     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .                iim,jjphy_nb,nhori, klev,1,klev,nvert, 32,
      .                "ave(X)", zsto,zout)
 #endif
@@ -352,60 +358,60 @@
 #else
          CALL histdef(nid_tra, "pyu1", "Vent niv 1", "-",
-     .                iim,jjm+1,nhori, 1,1,1, -99, 32,
+     .                iim,jjphy_nb,nhori, 1,1,1, -99, 32,
      .                "inst(X)",  zsto,zout)
 
          CALL histdef(nid_tra, "pyv1", "Vent niv 1", "-",
-     .                iim,jjm+1,nhori, 1,1,1, -99, 32,
+     .                iim,jjphy_nb,nhori, 1,1,1, -99, 32,
      .                "inst(X)",  zsto,zout)
          CALL histdef(nid_tra, "psrf1", "nature sol", "-",
-     .                iim,jjm+1,nhori, 1,1,1, -99, 32,
+     .                iim,jjphy_nb,nhori, 1,1,1, -99, 32,
      .                "inst(X)",  zsto,zout)
          CALL histdef(nid_tra, "psrf2", "nature sol", "-",
-     .                iim,jjm+1,nhori, 1,1,1, -99, 32,
+     .                iim,jjphy_nb,nhori, 1,1,1, -99, 32,
      .                "inst(X)",  zsto,zout)
          CALL histdef(nid_tra, "psrf3", "nature sol", "-",
-     .                iim,jjm+1,nhori, 1,1,1, -99, 32,
+     .                iim,jjphy_nb,nhori, 1,1,1, -99, 32,
      .                "inst(X)",  zsto,zout)
          CALL histdef(nid_tra, "psrf4", "nature sol", "-",
-     .                iim,jjm+1,nhori, 1,1,1, -99, 32,
+     .                iim,jjphy_nb,nhori, 1,1,1, -99, 32,
      .                "inst(X)",  zsto,zout)
          CALL histdef(nid_tra, "ftsol1", "temper sol", "-",
-     .                iim,jjm+1,nhori, 1,1,1, -99, 32,
+     .                iim,jjphy_nb,nhori, 1,1,1, -99, 32,
      .                "inst(X)",  zsto,zout)
          CALL histdef(nid_tra, "ftsol2", "temper sol", "-",
-     .                iim,jjm+1,nhori, 1,1,1, -99, 32,
+     .                iim,jjphy_nb,nhori, 1,1,1, -99, 32,
      .                "inst(X)",  zsto,zout)
          CALL histdef(nid_tra, "ftsol3", "temper sol", "-",
-     .                iim,jjm+1,nhori, 1,1,1, -99, 32,
+     .                iim,jjphy_nb,nhori, 1,1,1, -99, 32,
      .                "inst",  zsto,zout)
          CALL histdef(nid_tra, "ftsol4", "temper sol", "-",
-     .                iim,jjm+1,nhori, 1,1,1, -99, 32,
+     .                iim,jjphy_nb,nhori, 1,1,1, -99, 32,
      .                "inst(X)",  zsto,zout)
          CALL histdef(nid_tra, "pplay", "flux u mont","-",
-     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .                iim,jjphy_nb,nhori, klev,1,klev,nvert, 32,
      .                "inst(X)", zsto,zout)
          CALL histdef(nid_tra, "t", "flux u mont","-",
-     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .                iim,jjphy_nb,nhori, klev,1,klev,nvert, 32,
      .                "inst(X)", zsto,zout)
          CALL histdef(nid_tra, "mfu", "flux u mont","-",
-     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .                iim,jjphy_nb,nhori, klev,1,klev,nvert, 32,
      .                "ave(X)", zsto,zout)
          CALL histdef(nid_tra, "mfd", "flux u decen","-",
-     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .                iim,jjphy_nb,nhori, klev,1,klev,nvert, 32,
      .                "ave(X)", zsto,zout)
          CALL histdef(nid_tra, "en_u", "flux u mont","-",
-     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .                iim,jjphy_nb,nhori, klev,1,klev,nvert, 32,
      .                "ave(X)", zsto,zout)
          CALL histdef(nid_tra, "en_d", "flux u mont","-",
-     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .                iim,jjphy_nb,nhori, klev,1,klev,nvert, 32,
      .                "ave(X)", zsto,zout)
          CALL histdef(nid_tra, "de_d", "flux u mont","-",
-     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .                iim,jjphy_nb,nhori, klev,1,klev,nvert, 32,
      .                "ave(X)", zsto,zout)
          CALL histdef(nid_tra, "de_u", "flux u decen","-",
-     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .                iim,jjphy_nb,nhori, klev,1,klev,nvert, 32,
      .                "ave(X)", zsto,zout)
          CALL histdef(nid_tra, "coefh", "turbulent coef","-",
-     .                iim,jjm+1,nhori, klev,1,klev,nvert, 32,
+     .                iim,jjphy_nb,nhori, klev,1,klev,nvert, 32,
      .                "ave(X)", zsto,zout)
 
Index: /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/inifis.F
===================================================================
--- /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/inifis.F	(revision 633)
+++ /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/inifis.F	(revision 634)
@@ -7,4 +7,5 @@
      $           plat,plon,parea,
      $           prad,pg,pr,pcpp)
+      use dimphy
       IMPLICIT NONE
 c
@@ -41,6 +42,6 @@
 c   -------------
  
-#include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
 
       REAL prad,pg,pr,pcpp,punjours
Index: /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/iniphysiq.F
===================================================================
--- /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/iniphysiq.F	(revision 633)
+++ /LMDZ4/branches/LMDZ4_par_0/libf/phylmd/iniphysiq.F	(revision 634)
@@ -9,4 +9,6 @@
      $           plat,plon,parea,pcu,pcv,
      $           prad,pg,pr,pcpp)
+      USE dimphy,klon2=>klon,klon=>klon2
+      USE comgeomphy
       IMPLICIT NONE
 c
@@ -43,7 +45,7 @@
 c   -------------
  
-#include "dimensions.h"
-#include "dimphy.h"
-#include "comgeomphy.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
+cym#include "comgeomphy.h"
 
       REAL prad,pg,pr,pcpp,punjours
@@ -71,9 +73,9 @@
       ENDIF
 
-      airephy=parea
-      cuphy=pcu
-      cvphy=pcv
-      rlond = plon
-      rlatd = plat
+      airephy(1:klon2)=parea(klon_begin:klon_end)
+      cuphy(1:klon2)=pcu(klon_begin:klon_end)
+      cvphy(1:klon2)=pcv(klon_begin:klon_end)
+      rlond(1:klon2) = plon(klon_begin:klon_end)
+      rlatd(1:klon2) = plat(klon_begin:klon_end)
 
       call suphec
